package com.ejie.ab79.dao.inspecciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.inspecciones.Agrupaciones;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * AgrupacionesDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class AgrupacionesDaoImpl implements AgrupacionesDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDAGRUPACION", "IDDIRECCION", "DESCRIPCIONCORTA",
			"DESCRIPCIONCASTELLANO", "DESCRIPCIONEUSKERA", "DIRECCIONDESCES", "DIRECCIONDESCEU" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Agrupaciones> rwMap = new RowMapper<Agrupaciones>() {
		public Agrupaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Agrupaciones agrupacion = new Agrupaciones();
			agrupacion.setIdAgrupacion(resultSet.getInt("IDAGRUPACION"));
			agrupacion.setDescripcionCorta(resultSet.getString("DESCRIPCIONCORTA"));
			agrupacion.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			agrupacion.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			Direcciones direccion = new Direcciones(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DIRECCIONDESCES"));
			direccion.setDescripcionEuskera(resultSet.getString("DIRECCIONDESCEU"));

			agrupacion.setDireccion(direccion);

			return agrupacion;

		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Inserts a single row in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @return Agrupaciones
	 */
	public Agrupaciones add(Agrupaciones agrupacion) {

		int idAgrupacion = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7940T00.NEXTVAL FROM DUAL", Integer.class);
		agrupacion.setIdAgrupacion(idAgrupacion);

		String query = "INSERT INTO AGRUPACIONES (ID_AGRUPACION, ID_DIRECCION, DESCRIPCION_CORTA, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,SYSDATE,?)";
		this.jdbcTemplate.update(query, agrupacion.getIdAgrupacion(), agrupacion.getDireccion().getIdDireccion(),
				agrupacion.getDescripcionCorta(), agrupacion.getDescripcionCastellano(),
				agrupacion.getDescripcionEuskera(), agrupacion.getUsuarioRegistro());
		return agrupacion;
	}

	/**
	 * Updates a single row in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @return Agrupaciones
	 */
	public Agrupaciones update(Agrupaciones agrupacion) {
		String query = "UPDATE AGRUPACIONES SET ID_DIRECCION=?, DESCRIPCION_CORTA=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_AGRUPACION=?";
		this.jdbcTemplate.update(query, agrupacion.getDireccion().getIdDireccion(), agrupacion.getDescripcionCorta(),
				agrupacion.getDescripcionCastellano(), agrupacion.getDescripcionEuskera(),
				agrupacion.getUsuarioUltmodificacion(), agrupacion.getIdAgrupacion());
		return agrupacion;
	}

	/**
	 * Finds a single row in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @return Agrupaciones
	 */
	@Transactional(readOnly = true)
	public Agrupaciones find(Agrupaciones agrupacion) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT t7940.ID_AGRUPACION IDAGRUPACION, t7940.ID_DIRECCION IDDIRECCION, t7940.DESCRIPCION_CORTA DESCRIPCIONCORTA, t7940.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t7940.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t6113.DESCRIPCION_CASTELLANO DIRECCIONDESCES, t6113.DESCRIPCION_EUSKERA DIRECCIONDESCEU FROM AGRUPACIONES t7940, DIRECCIONES t6113 WHERE t7940.ID_AGRUPACION = ? AND t7940.ID_DIRECCION = t6113.ID_DIRECCION ");

		List<Agrupaciones> agrupacionesList = this.jdbcTemplate.query(query.toString(), this.rwMap,
				agrupacion.getIdAgrupacion());
		return (Agrupaciones) DataAccessUtils.uniqueResult(agrupacionesList);
	}

	/**
	 * Removes a single row in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @return
	 */
	public void remove(Agrupaciones agrupacion) {
		String query = "DELETE FROM AGRUPACIONES WHERE ID_AGRUPACION=?";
		this.jdbcTemplate.update(query, agrupacion.getIdAgrupacion());
	}

	/**
	 * Finds a list of rows in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Agrupaciones>
	 */
	@Transactional(readOnly = true)
	public List<Agrupaciones> findAll(Agrupaciones agrupacion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT t7940.ID_AGRUPACION IDAGRUPACION, t7940.ID_DIRECCION IDDIRECCION, t7940.DESCRIPCION_CORTA DESCRIPCIONCORTA, t7940.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t7940.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t6113.DESCRIPCION_CASTELLANO DIRECCIONDESCES, t6113.DESCRIPCION_EUSKERA DIRECCIONDESCEU FROM AGRUPACIONES t7940, DIRECCIONES t6113 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(agrupacion);
		StringBuilder where = new StringBuilder();
		query.append(" WHERE 1=1 AND t7940.ID_DIRECCION = t6113.ID_DIRECCION ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, AgrupacionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Agrupaciones>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the Agrupaciones table using like.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Agrupaciones>
	 */
	@Transactional(readOnly = true)
	public List<Agrupaciones> findAllLike(Agrupaciones agrupacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT t7940.ID_AGRUPACION IDAGRUPACION, t7940.ID_DIRECCION IDDIRECCION, t7940.DESCRIPCION_CORTA DESCRIPCIONCORTA, t7940.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t7940.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t6113.DESCRIPCION_CASTELLANO DIRECCIONDESCES, t6113.DESCRIPCION_EUSKERA DIRECCIONDESCEU FROM AGRUPACIONES t7940, DIRECCIONES t6113 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(agrupacion, startsWith);
		StringBuilder where = new StringBuilder();
		query.append(" WHERE 1=1 AND t7940.ID_DIRECCION = t6113.ID_DIRECCION ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return (List<Agrupaciones>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Agrupaciones table.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(Agrupaciones agrupacion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM AGRUPACIONES t7940 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(agrupacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Agrupaciones table using like.
	 *
	 * @param agrupacion
	 *            Agrupaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Agrupaciones agrupacion, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM AGRUPACIONES t7940 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(agrupacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Agrupaciones entity
	 *
	 * @param agrupacion
	 *            Agrupaciones Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Agrupaciones agrupacion) {

		StringBuilder where = new StringBuilder(AgrupacionesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (agrupacion != null && agrupacion.getIdAgrupacion() != null) {
			where.append(" AND t7940.ID_AGRUPACION = ?");
			params.add(agrupacion.getIdAgrupacion());
		}
		if (agrupacion != null && agrupacion.getDireccion() != null
				&& agrupacion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t7940.ID_DIRECCION = ?");
			params.add(agrupacion.getDireccion().getIdDireccion());
		}
		if (agrupacion != null && agrupacion.getDescripcionCorta() != null) {
			where.append(" AND t7940.DESCRIPCION_CORTA = ?");
			params.add(agrupacion.getDescripcionCorta());
		}
		if (agrupacion != null && agrupacion.getDescripcionCastellano() != null) {
			where.append(" AND t7940.DESCRIPCION_CASTELLANO = ?");
			params.add(agrupacion.getDescripcionCastellano());
		}
		if (agrupacion != null && agrupacion.getDescripcionEuskera() != null) {
			where.append(" AND t7940.DESCRIPCION_EUSKERA = ?");
			params.add(agrupacion.getDescripcionEuskera());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Agrupaciones entity
	 *
	 * @param agrupacion
	 *            Agrupaciones Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Agrupaciones agrupacion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(AgrupacionesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (agrupacion != null && agrupacion.getIdAgrupacion() != null) {
			where.append(" AND t7940.ID_AGRUPACION = ?");
			params.add(agrupacion.getIdAgrupacion());
		}
		if (agrupacion != null && agrupacion.getDireccion() != null
				&& agrupacion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t7940.ID_DIRECCION = ?");
			params.add(agrupacion.getDireccion().getIdDireccion());
		}
		if (agrupacion != null && agrupacion.getDescripcionCorta() != null) {
			where.append(" AND UPPER(t7940.DESCRIPCION_CORTA) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(agrupacion.getDescripcionCorta().toUpperCase() + "%");
			} else {
				params.add("%" + agrupacion.getDescripcionCorta().toUpperCase() + "%");
			}
			where.append(" AND t7940.DESCRIPCION_CORTA IS NOT NULL");
		}
		if (agrupacion != null && agrupacion.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t7940.DESCRIPCION_CASTELLANO) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(agrupacion.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + agrupacion.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t7940.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (agrupacion != null && agrupacion.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t7940.DESCRIPCION_EUSKERA) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(agrupacion.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + agrupacion.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t7940.DESCRIPCION_EUSKERA IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
